eval 'exec perl -w -S $0 ${1+"$@"}'
  if 0;

if ( $#ARGV < 0 )
  {
    print <<'EOF';
#..............................................................................
#...configure.pl                                                            ...
#...                                                                        ...
#...Usage: configure.pl [flags] <help|go|print|redo|redo_print> [options]   ...
#...                                                                        ...
#...Description:                                                            ...
#...                                                                        ...
#...   [flags]: -d <output directory name>                                  ...
#...               This overrides the default which is the current working  ...
#...               directory.                                               ...
#...            -i <input file name>                                        ...
#...               overrides default input file name of 'configure.dat'     ...
#...            -only                                                       ...
#...               This will only create variables listed in configure.dat  ...
#...               The file created will be make_only.inc                   ...
#...            -o <output file name>                                       ...
#...               overrides default output file name of 'make.inc'         ...
#...   help:       describe the different options                           ...
#...   go:         create make.inc from configure.dat                       ...
#...   print:      just print make.inc to stdout                            ...
#...   redo:       recreate make.inc with same command line options plus    ...
#...               any additional ones listed afterwards                    ...
#...               works just like you typed in:                            ...
#...                  configure.pl go <previous options> <additional opts>  ...
#...   redo_print: same as redo, but just print to stdout                   ...
#...   [options]:  modify settings derived from the datafile                ...
#...                  [+option]: add to       configure.dat options         ...
#...                  [-option]: remove from  all           options         ...
#...                  [option] : assign new   configure.dat options         ...
#...                  [MAKE_VARIABLE=VALUE]:  assign gmake variable (=)     ...
#...                  [MAKE_VARIABLE:=VALUE]: assign gmake variable (:=)    ...
#...                  [MAKE_VARIABLE+=VALUE]: add to gmake variable         ...
#...                                          additions separated by 1 space...
#...               options evaulated in order so last one listed wins:      ...
#...                     +foo -foo    --> -foo                              ...
#...                     VAR=a VAR+=b --> VAR+=b                            ...
#...                                                                        ...
#...   configure.pl creates make.inc from configure.dat                     ...
#...   configure.dat contains information about variable definitions        ...
#...   verbatim quotes, and help info.                                      ...
#...   See configure.dat for a description on that file.                    ...
#...                                                                        ...
#...configure.dat Format                                                    ...
#...   The following describes the format of the configure.dat file         ...
#...                                                                        ...
#...   1) Help Block                                                        ...
#...      Regions bounded by the lines -                                    ...
#...         begin help:                                                    ...
#...         end help:                                                      ...
#...      will be printed if the command 'configure.pl help' is run.        ...
#...                                                                        ...
#...   2) Exclusive Block                                                   ...
#...      Regions bounded by the lines -                                    ...
#...         begin exclusive:                                               ...
#...         end exclusive:                                                 ...
#...      list options that are mutually exclusive.  Each line represents   ...
#...      a block of options in which only one option can be set.  If more  ...
#...      that one option in a line is seen, only 1 will be used.  The      ...
#...      following is the priority (highest to lowest):                    ...
#...           - option given on configure.pl line                          ...
#...           - CONFIGURE_OPTIONS specified in configure.dat               ...
#...                                                                        ...
#...   3) Verbatim Block                                                    ...
#...      Regions bounded by the lines -                                    ...
#...         begin verbatim:                                                ...
#...         end verbatim:                                                  ...
#...      will be placed directly in make.inc after the variable            ...
#...      definitions.                                                      ...
#...                                                                        ...
#...   4) Variable Definition Line                                          ...
#...      Lines not in the above blocks are considered variable lines.      ...
#...      Lines beginning with # (commane lines).                           ...
#...      Lines ending in \ are continued on the next line.                 ...
#...                                                                        ...
#...      Variables are defined depending upon the options set.             ...
#...      Format:                                                           ...
#...         <VARIABLE_NAME>([option] [option] ... )  = [value]             ...
#...         <VARIABLE_NAME>([option] [option] ... ) := [value]             ...
#...         <VARIABLE_NAME>([option] [option] ... ) += [value]             ...
#...                                                                        ...
#...      Each option is a single word that is a perl regular expression.   ...
#...      Be careful with using whitespace, =, or () since they have        ...
#...      special meanings in this script.                                  ...
#...                                                                        ...
#...      Basically, if all the options of a variable are satisfied, that   ...
#...      variable is set to the value.                                     ...
#...                                                                        ...
#...      The original goal of this script was to allow users to do         ...
#...      something like the following:                                     ...
#...        CFLAGS(irix) = -mips4                                           ...
#...        CFLAGS(sun)  = -xtarget=ultra -xarch=v9                         ...
#...        CC()         = cc                                               ...
#...      So, CFLAGS is defined different depending upon what option(s) is  ...
#...      set.  Then, CC is always defined the same way.                    ...
#...                                                                        ...
#...      configure.pl initialially sets some options (for example          ...
#...      architecture "irix" and machine name "theta").  These options are ...
#...      predefined options.  These predefined options along with command  ...
#...      line options are used by the variable CONFIGURE_OPTIONS to set    ...
#...      additional options.                                               ...
#...      Finally, the predefined, command line, and CONFIGURE_OPTIONS are  ...
#...      used to determine what variables are set.                         ...
#...                                                                        ...
#...      The following examples show how configure.pl chooses the way a    ...
#...      variable is defined (using the variable CFLAGS as the example     ...
#....     variable):                                                        ...
#...                                                                        ...
#...        - Assigning depending upon options set.                         ...
#...          Variable values may be assigned by using = or :=              ...
#...          If the following variable are listed, CFLAGS is defined       ...
#...          depending on what options are set:                            ...
#...          CFLAGS()     = Define when no other choice fits.              ...
#...                         Number options satisfied: 0 out of 0           ...
#...                         This satisfies all the options required (zero  ...
#...                         options satisfied but zero required).          ...
#...          CFLAGS(a b)  = Define when both a and b are supplied.         ...
#...                         Number options satisfied: 2 out of 2           ...
#...                         Choose the variable with the most options      ...
#...                         satisfied.                                     ...
#...                         Note, both a and b must be supplied.  If only a...
#...                         was supplied, this definition would never be   ...
#...                         chosen since both a and b are required for     ...
#...                         CFLAGS(a b) to be satisfied.                   ...
#...          CFLAGS(a)    = Define when a but not b is supplied.           ...
#...                         Number options satisfied: 1 out of 1           ...
#...                         If b was also defined, CFLAGS(a b) would be    ...
#...                         chosen over CFLAGS(a) since it is satisfied    ...
#...                         and it satisfies more options.                 ...
#...          CFLAGS(c)    = Define when c but not a is supplied.           ...
#...                         Number options satisfied: 1 out of 1           ...
#...                         If a had been satisfied also, there would be a ...
#...                         tie in the number of options satisfied between ...
#...                         CFLAGS(a) and CFLAGS(c) = 1 option.  In the    ...
#...                         case of a tie, the variable listed first wins. ...
#...                         Again, if a _and_ b had been defined,          ...
#...                         CFLAGS(a b) would have won regardless of where ...
#...                         it was listed since it satisfies 2 options.    ...
#...                                                                        ...
#...        - Appending values                                              ...
#...          Variable values may be appended to by using +=                ...
#...          CFLAGS(a b) += also add to value if both a and b are supplied ...
#...          CFLAGS(a)   += also add to value if a is supplied             ...
#...          So, if a and b are supplied, CFLAGS(a b) and CFLAGS(a) will   ...
#...          be appended (in that order) since that is how they are listed)...
#...          to any absolute value for CFLAGS.                             ...
#...                                                                        ...
#...        - Additional modifiers:                                         ...
#...          CFLAGS(!b)       = Define when b is not supplied              ...
#...                             Number options satisfied: 1 out of 1       ...
#...          CFLAGS(!a b | c) = Define when ((!a) b) | (c)                 ...
#...                             Number of options satisfied: 2 or 1        ...
#...                             | separates blocks of options.             ...
#...                             The number of options satisfied depends    ...
#...                             upon which option block is satisfied.  If  ...
#...                             multiple blocks are satisfied, the number  ...
#...                             is the number of options in the largest    ...
#...                             satisfied option block.                    ...
#...                              - a, b, and c are supplied                ...
#...                                Number of options satisfied = 1 (c)     ...
#...                              - !a, b are supplied                      ...
#...                                Number of options satisfied = 2 (!a b)  ...
#...                                (regardless of whether c is supplied)   ...
#...                              - !a, !b, c                               ...
#...                                There is now a tie in the number of     ...
#...                                options satisfied with CFLAGS(!b) and   ...
#...                                CFLAGS(!a b | c) being 1.  So,          ...
#...                                CFLAGS(!b) is chosen since it was listed...
#...                                first.                                  ...
#...                                                                        ...
#..............................................................................
EOF
    exit;

  }
#..............................................................................
#...Flow:                                                                   ...
#...   1) read configure.dat                                                ...
#...   2) get defined options                                               ...
#...   3) foreach variable group,                                           ...
#...   3a)  make list of which variables are satisfied from the defined     ...
#...        options                                                         ...
#...   3b)  from this list of satisfied variables, pick the first one       ...
#...        that has the largest set of requirements                        ...
#...   4) create default variables                                          ...
#...   5) print to screen or print to file depending upon command line      ...
#...      option                                                            ...
#..............................................................................
my(
   $absolute_options, # whether or not command line options were absolute
   @all_requirements, # array of all meaningful options
   @argv_remaining, # remaining args not processed yet
   $assignment, # if directive (:) or variable (=)
   %block, # $block{$block_name} = lines for that block
   $block_name, # verbatim, help, ...
   $block_start, # starting line for the block
   $block_done, # "true" or "false" - done with block
   $change_option, # option to be changed (+ or -)
   $command_line_option, # split of $command_line_options
   $command_line_options, # options given on command line (no variables)
   $command_line_options_added, # options added via command line
   $command_line_options_absolute, # absolute options via command line
   $command_line_arg, # foreach @command_line_arg...
   @command_line_args, # command line args
   %command_line_variable, # foreach %command_line_variables
   %command_line_variables, # command line assignments for make.inc variables
   $computer_name, # COMPUTER_NAME set to this
   $continuation_line, # the line continued by a "\" on previous line
   $create_file, # whether to print output to file or screen
   $current_working_directory, # DIR_TOP_SRCDIR set to this
   $current_working_directory_command, # command to get the current working dir
   $datafile_options, # options defined by the input file
   $datafile_options_old, # previous pass of options defined by input file
   $date, # todays date
   $done, # whether done with a task
   $done_continuation, # whether on a continuation line
   @file_lines, # lines of the input file
   $file_string, # lines of the file joined together
   $help, # "true" if help is the option, "false" otherwise
   $i, # loop variable
   $ierr, # error return value
   $input_file, # configure.dat
   $line, # printed line in error messages
   $line_number, # current 1 based line number being parsed
   $max_name_length, # for lining up variable in output file
   $new_version, # new version dictated by cvs status -v README
   $only, # true/false: only create variables listed in configure.dat
   $option, # current predefined option
   $options, # set of all defined options
   $output_file, # relative name of output file
   $output_file_full, # $output_dir/$output_file
   $output_dir, # directory to make.inc
   $predefined_option_name, # current name of predefined option
   $predefined_options, # whitespace list of options automatically defined
   %predefined_options_all, # {$predefined_option_name} = all possibilities
   $requirement, # one requirement of variable in input file
   %requirement_list, # {$requirement} = true (hash for printing)
   $requirements, # all requirements of a variable in input file
   $requirements_total, # get all possible options
   %seen, # used for finding unique items in list
   $temp_output, # output from system calls
   $this_line, # current file_lines to be modified
   $total_output, # output to be printed to output file
   $value, # value of variable in input file
   $variable, # variable in input file
   %variable_group, # {variable} = "$requirement=$value\n(another pair)\n..."
   %variable_group_temp, # variable_group with temporary group
   %variable_output, # {variable} = $value (printed to output file)
   %variable_assign, # assignment of the variable (eg =,:=,...)
   $variable_results, # final output for variables
  );

print "\n  $0 ", join( " ", @ARGV ),"\n";

#............................................................................
#....................assign default variables................................
#............................................................................
$current_working_directory_command = 'pwd';
$current_working_directory = `$current_working_directory_command`;
$current_working_directory =~ s/\s*$//;
if ( $current_working_directory !~ /\S/ )
  {
    $ierr = -1;
    &print_error( "Cannot find current working directory", $ierr );
    exit( $ierr );
  }

$computer_name = `uname -n`;
chop( $computer_name );
#..................................
#...parse flags then main option...
#..................................
@argv_remaining = @ARGV;
$input_file = './configure.dat';
$output_file = 'make.inc';
$output_dir = "$current_working_directory";
$help = "false";
$create_file = "false";
$redo_file = "false";
$done = "false";
$only = "false";
while( $done eq "false" )
  {
    if( $#argv_remaining < 0 )
      {
        $ierr = -1;
        &print_error( "Could not find argument <go|help|print|redo|redo_print>",
                      "(perhaps missing argument to -d/-i/-o/... flag?)",
                      $ierr );
        exit( $ierr );
      }
    elsif( $argv_remaining[0] eq "-d" )
      {
        if( $#argv_remaining <= 0 )
          {
            $ierr = -1;
            &print_error( "missing argument to $argv_remaining[0] option",
                          $ierr );
            exit( $ierr );
          }
        shift( @argv_remaining );
        $output_dir = shift( @argv_remaining );
        $output_dir =~ s/^\s*//;
        $output_dir =~ s/\s*$//;
        if( $output_dir !~ /^\// )
          {
            $output_dir = "$current_working_directory/$output_dir";
          }
        $output_dir = &path_comp($output_dir);
      }
    elsif( $argv_remaining[0] eq "-i" )
      {
        if( $#argv_remaining <= 0 )
          {
            $ierr = -1;
            &print_error( "missing argument to $argv_remaining[0] option",
                          $ierr );
            exit( $ierr );
          }
        shift( @argv_remaining );
        $input_file = shift( @argv_remaining );
      }
    elsif( $argv_remaining[0] eq "-o" )
      {
        if( $#argv_remaining <= 0 )
          {
            $ierr = -1;
            &print_error( "missing argument to $argv_remaining[0] option",
                          $ierr );
            exit( $ierr );
          }
        shift( @argv_remaining );
        $output_file = shift( @argv_remaining );
        if( $output_file =~ /\// )
          {
            $ierr = -1;
            &print_error( "Replacement make.inc name must not contain '/'.",
                          "Use -d option to change output directory.",
                          $output_file,
                          $ierr );
            exit( $ierr );
          }
      }
    elsif( $argv_remaining[0] eq "-only" )
      {
        shift( @argv_remaining );
        $only = "true";
      }
    elsif( $argv_remaining[0] =~ /-*help/ )
      {
        shift( @argv_remaining );
        $help = "true";
        $done = "true";
      }
    elsif( $argv_remaining[0] eq "go" )
      {
        shift( @argv_remaining );
        $create_file = "true";
        $redo_file = "false";
        $done = "true";
      }
    elsif( $argv_remaining[0] eq "print" )
      {
        shift( @argv_remaining );
        $create_file = "false";
        $redo_file = "false";
        $done = "true";
      }
    elsif( $argv_remaining[0] eq "redo" )
      {
        shift( @argv_remaining );
        $create_file = "true";
        $redo_file = "true";
        $done = "true";
      }
    elsif( $argv_remaining[0] eq "redo_print" )
      {
        shift( @argv_remaining );
        $create_file = "false";
        $redo_file = "true";
        $done = "true";
      }
    else
      {
        $ierr = -1;
        &print_error( "Invalid flag: [$argv_remaining[0]] ", $ierr );
        exit( $ierr );
      }
  }
$output_file_full = "$output_dir/$output_file";
@command_line_args = @argv_remaining;
#........................................
#...DONE: parse flags then main option...
#........................................
#.......................................................
#...get command line args that modifies configure.dat...
#.......................................................
@command_line_args_redo = ();
if( $redo_file eq "true" && -T $output_file_full && -r $output_file_full )
  {
    open( FILE, $output_file_full );
    @file_lines = <FILE>;
    close( FILE );
    $file_string = join( "", @file_lines );
    if( $file_string =~
        /
        \n\#\.\.\.Begin\ Command\ Line\ Args # start of the command line opts
        ((.|\n)*) # command line opts - 1 per line
        \n\#\.\.\.End\ Command\ Line\ Args\n # finish of the command line opts
        /x
      )
      {
        @command_line_args_redo = split( /\n\#\.\.\. /, $1 );
        shift( @command_line_args_redo );
      }
  }
#..............
#...get date...
#..............
$date = `date '+%y%m%d %H%M%S'`;
chop ( $date );
#...............
#...init vars...
#...............
$requirements_total = "";
$block_names = "exclusive|help|verbatim";
$block{exclusive} = "";
#...............................
#...assign predefined options...
#...............................
$predefined_options = "";
#......................
#...set architecture...
#......................
$option = "";
$predefined_option_name =
  "architecture";
$predefined_options_all{"$predefined_option_name"} =
  "aix alpha cray hp irix linux tflop sun win32";
$temp_output = `uname -a`;
if ( $temp_output =~ /\bAIX/ )
  {
    $option = "aix";
  }
elsif ( $temp_output =~ /\balpha/ )
  {
    $option = "alpha";
  }
elsif ( $temp_output =~ /\bCRAY\b/ )
  {
    $option = "cray";
  }
elsif ( $temp_output =~ /\bHPUX\b/ )
  {
    $option = "hp";
  }
elsif ( $temp_output =~ /\bIRIX/ )
  {
    $option = "irix";
  }
elsif ( $temp_output =~ /\bLinux\b/ )
  {
    $option = "linux";
  }
#.................................................................
#...Note that compilations are done on sasn### which is a sun. ...
#...So, check for this machine first.                          ...
#.................................................................
elsif ( $temp_output =~ /\b(janus|sasn100|sasn101)\b/ )
  {
    $option = "tflop";
  }
elsif ( $temp_output =~ /\bSunOS\b/ )
  {
    $option = "sun";
  }
elsif ( $temp_output =~ /\bWindows\b/ )
  {
    $option = "win32";
  }

if ( $option !~ /\S/ )
  {
    $ierr = -1;
    &print_error( "Cannot determine [$predefined_option_name].",
                  "Possibilities: [$predefined_options_all{$predefined_option_name}]",
                  $ierr
                );
    exit( $ierr );
  }
$predefined_options .= " $option ";
#............................
#...DONE: set architecture...
#............................
#.......................
#...set computer name...
#.......................
$option = "";
$predefined_option_name =
  "computer_name";
$predefined_options_all{"$predefined_option_name"} =
  "from uname -n";
$option = $computer_name;
if ( $option !~ /^\S+$/ )
  {
    $ierr = -1;
    &print_error( "Cannot determine [$predefined_option_name].",
                  "Possibilities: [$predefined_options_all{$predefined_option_name}]",
                  $ierr
                );
    exit( $ierr );
  }
$predefined_options .= " $option ";
#.............................
#...DONE: set computer name...
#.............................
#.......................................................
#...have 1 space between options and unique-sort list...
#.......................................................
$predefined_options =~ s/\s+/ /g;
$predefined_options =~ s/^\s+//;
$predefined_options =~ s/\s+$//;
#......................
#...unique-sort list...
#......................
%seen = ();
$predefined_options = join( " ", 
                            sort grep{ ! $seen{$_}++ } 
                            split( /\s+/, $predefined_options ) );
#.....................................
#...DONE: assign predefined options...
#.....................................
#............................
#...read in configure file...
#............................
print "    Parsing  input  file [$input_file]\n";
if ( ! open (FILE, $input_file) )
  {
    undef( @file_lines );
    $file_lines[0] = "";
  }
else
  {
    @file_lines = <FILE>;
    close ( FILE );
  }
#.......................................................................
#...parse the lines of the file into the variables and the directives...
#.......................................................................
$done = "false";
$i = 0;
undef( %variable_group );
undef( %variable_assign );
while ( $done eq "false" )
  {
    #.......................
    #...stop at last line...
    #.......................
    if ( $i > $#file_lines )
      {
        $done = "true";
        last;
      }
    #...................................................
    #...create copy of this line that can be modified...
    #...................................................
    $this_line = $file_lines[$i];
    #.............................
    #...join continuation lines...
    #.............................
    if ( $this_line =~ /\\\s*$/ )
      {
        #...............................................
        #...remove continuation marker and whitespace...
        #...............................................
        $this_line =~ s/\\\s*$//;
        #...................................................
        #...process the entire continuation for this line...
        #...................................................
        $done_continuation = "false";
        while ( $done_continuation eq "false" )
          {
            #............................
            #...increment to next line...
            #............................
            $i++;
            
            #..........................
            #...stop if at last line...
            #..........................
            if ( $i > $#file_lines )
              {
                $done_continuation = "true";
                $done = "true";
                last;
              }
            #...........................................................
            #...remove beginning whitespace and add line to this_line...
            #...........................................................
            $continuation_line = $file_lines[$i];
            $continuation_line =~ s/^\s*//;
            $this_line .= $continuation_line;
            #...............................................
            #...note if you continue on this line as well...
            #...and remove continuation marker/whitespace...
            #...............................................
            if ( $this_line =~ /\\\s*$/ )
                {
                  $done_continuation = "false";
                  $this_line =~ s/\\\s*$//;
                }
            #...............................................
            #...if this is last continuation, note it and...
            #...remove trailing whitespace               ...
            #...............................................
            else
              {
                $done_continuation = "true";
                $this_line =~ s/\s*$//;
              }
          }
        #.........................................................
        #...DONE: process the entire continuation for this line...
        #.........................................................
      }
    #...................................
    #...DONE: join continuation lines...
    #...................................
    #..................................
    #...skip blank and comment lines...
    #..................................
    if ( $this_line =~ /^\s*$/ || $this_line =~ /^\s*\#/ )
      {
        $i++;
        next;
      }
    #.........................................
    #...if you get to a variable definition...
    #.........................................
    if ( $this_line =~ 
         /
         ^\s*                 # beginning plus whitespace
         ([\w\-]+)            # variable (word characters or a dash)
         \s*                  # whitespace
         \(\s*(.*?)\s*\)      # ( <whitespace requirements list> )
         \s*((\+|:)?=)\s*     # +=, :=, =
         (.*)                 # <value>
         \s*$                 # whitespace plus ending
         /x )
      {
        #.....................................................
        #...assign variable, its requirement, and the value...
        #.....................................................
        $variable = $1;
        $requirements = $2;
        $assignment = $3;
        $value = $5;
        #.......................................
        #...strip leading and trailing blanks...
        #.......................................
        $variable =~ s/^\s*//;
        $variable =~ s/\s*$//;
        $requirements =~ s/^\s*//;
        $requirements =~ s/\s*$//;
        $value =~ s/^\s*//;
        $value =~ s/\s*$//;
        #...............................................................
        #...add to the requirements_total variable for a print option...
        #...............................................................
        $requirements_total .= " $requirements ";
        $requirements_total =~ s/\!\s*//g;
        $requirements_total =~ s/\s*\|\s*/ /g;
        #....................................
        #...add variable to variable group...
        #....................................
        if ( ! defined $variable_group{"$variable"} )
          {
            $variable_group{"$variable"} = "";
          }
        if( $requirements =~ /\073/ )
          {
            $ierr = -1;
            $line_number = $i + 1;
            &print_error( "$input_file:$line_number",
                          "You may not have a ';' in the requirements",
                          "[$requirements]",
                          $ierr
                        );
            exit( $ierr );
          }
        $variable_group{"$variable"} .= 
          "$requirements;$assignment;$value\n";
      }
    #...........................................
    #...DONE: processed a variable definition...
    #...........................................
    #.........................................
    #...otherwise, must be a directive line...
    #.........................................
    else
      {
        #....................
        #...special blocks...
        #....................
        if ( $this_line =~ /^\s*begin\s+($block_names)\s*:\s*$/i )
          {
            $block_name = $1;
            if( !defined( $block{$block_name} ) )
              {
                $block{$block_name} = "";
              }
            #..............................
            #...process the entire block...
            #..............................
            $block_start = $i+1;
            $block_done = "false";
            while ( $block_done eq "false" )
              {
                #............................
                #...increment to next line...
                #............................
                $i++;
                #..........................
                #...stop if at last line...
                #..........................
                if ( $i > $#file_lines )
                  {
                    $ierr = -1;
                    $line_number = $i + 1;
                    &print_error( "$input_file:$line_number",
                                  "Cannot find [end $block_name:].",
                                  "Begin block on line ".
                                  "$input_file:$block_start",
                                  $ierr
                                );
                    exit( $ierr );
                  }
                #...........................................................
                #...if you hit "end $block_name:" you are done with block...
                #...........................................................
                if ( $file_lines[$i] =~ /^\s*end\s+$block_name\s*:\s*$/i )
                  {
                    $block_done = "true";
                    $block{$block_name} .= "\n";
                    last;
                  }
                #...............................
                #...tack on this to the block...
                #...............................
                $block{$block_name} .= $file_lines[$i];
              }
            #...........................................
            #...DONE: entire block has been processed...
            #...........................................
          }
        #........................................................
        #...Done: we hit the start of a block and processed it...
        #........................................................
        #.......................
        #...unknown directive...
        #....................... 
        else
          {
            $ierr = -1;
            $line_number = $i + 1;
            $line = $file_lines[$i];
            chop( $line );
            &print_error( "$input_file:$line_number",
                          "[$line]",
                          "Unknown directive",
                          "Possible missing continuation character on line $i.",
                          $ierr
                        );
            exit( $ierr );
          }
      }
    #.................................
    #...DONE: processed a directive...
    #.................................

    #.....................
    #...go to next line...
    #.....................
    $i++;
  }
#...................................................................
#...DONE: each variable line (with continuations) has been placed...
#...      inside a variable_group                                ...
#...................................................................
#........................................................................
#...get initial set of command line options affecting datafile_options...
#........................................................................
$command_line_options = "";
@command_line_args = @command_line_args_redo;
push( @command_line_args, @argv_remaining );
foreach $command_line_arg ( @command_line_args )
  {
    #.............
    #...+OPTION...
    #.............
    if ( $command_line_arg =~ /^\+([^=\s]\S*)$/ )
      {
        $change_option = $1;
        $command_line_options .= " $command_line_arg";
      }
    #.............
    #...-OPTION...
    #.............
    elsif ( $command_line_arg =~ /^\-([^=\s]\S*)$/ )
      {
        $change_option = $1;
        #...................................
        #...remove options so far defined...
        #...................................
        $command_line_options =~ s/\b$change_option\b/ /g;
      }
    #....................
    #...VAR=DEFINITION...
    #....................
    elsif ( $command_line_arg =~ /^([\w]+)((\+|:)?=.*)$/ )
      {
        #...nothing for now...
      }
    #............
    #...OPTION...
    #............
    else
      {
        $command_line_options .= " $command_line_arg";
      }
  }
$command_line_options =~ s/^\s*//;
$command_line_options =~ s/\s*$//;
$command_line_options =~ s/\s+/ /g;
#..............................................................................
#...DONE: get initial set of command line options affecting datafile_options...
#..............................................................................
#........................................................................
#...get CONFIGURE_OPTIONS/datafile_options based on predefined options...
#...and command_line_options                                          ...
#........................................................................
undef( %variable_output );
undef( %variable_assign );
$datafile_options = "";
undef( $datafile_options_old );
if ( defined $variable_group{CONFIGURE_OPTIONS} )
  {
    #.........................................................
    #...repeat processing CONFIGURE_OPTIONS until no change...
    #.........................................................
    while( ( ! defined( $datafile_options_old ) ) ||
           ( $datafile_options_old ne $datafile_options ) )
      {
        $datafile_options_old = $datafile_options;
        %variable_group_temp = (
                                "CONFIGURE_OPTIONS" => 
                                "$variable_group{CONFIGURE_OPTIONS}"
                               );
        $ierr = &get_variable_output(
                                     \%variable_group_temp,
                                     "$predefined_options ".
                                     "$command_line_options ".
                                     "$datafile_options_old ",
                                     \%variable_output,
                                     \%variable_assign
                                    );
        if ( $ierr )
          {
            &print_error( "get_variable_output", $ierr );
            exit( $ierr );
          }
        if( defined( $variable_output{"CONFIGURE_OPTIONS"} ) )
          {
            $datafile_options = $variable_output{"CONFIGURE_OPTIONS"};
          }
        delete( $variable_output{"CONFIGURE_OPTIONS"} );
        delete( $variable_assign{"CONFIGURE_OPTIONS"} );
        #......................
        #...unique-sort list...
        #......................
        %seen = ();
        $datafile_options = join( " ", 
                                  sort grep{ ! $seen{$_}++ } 
                                  split( /\s+/, $datafile_options ) );
      }
    #...............................................................
    #...DONE: repeat processing CONFIGURE_OPTIONS until no change...
    #...............................................................
  }
#..............................................................................
#...DONE: get CONFIGURE_OPTIONS/datafile_options based on predefined options...
#..............................................................................
#........................................
#...set command line options/variables...
#........................................
$command_line_options = "";
$command_line_options_added = "";
$command_line_options_absolute = "";
%command_line_variables = ();
@command_line_args = @command_line_args_redo;
push( @command_line_args, @argv_remaining );
foreach $command_line_arg ( @command_line_args )
  {
    #.............
    #...+OPTION...
    #.............
    if ( $command_line_arg =~ /^\+([^=\s]\S*)$/ )
      {
        $change_option = $1;
        $command_line_options_added .= " $change_option";
        $command_line_options .= " $command_line_arg";
      }
    #.............
    #...-OPTION...
    #.............
    elsif ( $command_line_arg =~ /^\-([^=\s]\S*)$/ )
      {
        $change_option = $1;
        #...................................
        #...remove options so far defined...
        #...................................
        $command_line_options_added =~ s/\b$change_option\b/ /g;
        $command_line_options_absolute =~ s/\b$change_option\b/ /g;
        $datafile_options =~ s/\b$change_option\b/ /g;
        $command_line_options .= " $command_line_arg";
      }
    #....................
    #...VAR=DEFINITION...
    #....................
    elsif ( $command_line_arg =~ /^([\w]+)((\+|:)?=.*)$/ )
      {
        $command_line_variables{$1} = $2;
      }
    #............
    #...OPTION...
    #............
    else
      {
        $command_line_options_absolute .= " $command_line_arg";
        $command_line_options .= " $command_line_arg";
      }
  }
$command_line_options =~ s/^\s*//;
$command_line_options =~ s/\s*$//;
$command_line_options =~ s/\s+/ /g;
#..............................................
#...DONE: set command line options/variables...
#..............................................
#.......................
#...set final options...
#.......................
#.......................................................................
#...set options in order so absolute, added, datafile will get pruned...
#.......................................................................
$options = $datafile_options;
if ( $command_line_options_absolute =~ /\S/ )
  {
    $options = $command_line_options_absolute;
  }
$options =
  "$predefined_options ".
  "$command_line_options_added ".
  "$options";
$options =~ s/\s+/ /g;
$options =~ s/^\s*//;
$options =~ s/\s*$//;
#......................................................................
#...exclusive prune options                                         ...
#...$options is ordered so predefined, added, datafile are preferred...
#......................................................................
&exclusive_prune( $block{exclusive}, \$options );
#.................
#...unique list...
#.................
%seen = ();
$options = join( " ", 
                 grep{ ! $seen{$_}++ } split( /\s+/, $options ) );
#.............................
#...DONE: set final options...
#.............................
#.........................................
#...get variables with complete options...
#.........................................
undef( %variable_output );
undef( %variable_assign );
$ierr = &get_variable_output(
                             \%variable_group,
                             $options,
                             \%variable_output,
                             \%variable_assign
                            );
if ( $ierr )
  {
    &print_error( "get_variable_output", $ierr );
    exit( $ierr );
  }
#..........................................................
#...undefine here so the predefined checking below works...
#..........................................................
delete( $variable_output{"CONFIGURE_OPTIONS"} );
delete( $variable_assign{"CONFIGURE_OPTIONS"} );
#...............................................................
#...assign command line variables.                           ...
#...Do before default variables in case they are used there. ...
#...............................................................
foreach $command_line_variable ( sort keys %command_line_variables )
  {
    #................
    #...assignment...
    #................
    if ( $command_line_variables{$command_line_variable} =~ 
         /^((:)?=)(.*)$/ )
      {
        $variable_assign{$command_line_variable} = $1;
        $variable_output{$command_line_variable} = $3;
      }
    #..............
    #...addition...
    #..............
    elsif ( $command_line_variables{$command_line_variable} =~ 
            /^\+=(.*)$/ )
      {
        if ( ! defined( $variable_output{$command_line_variable} ) )
          {
            $variable_output{$command_line_variable} = $1;
            $variable_assign{$command_line_variable} = "=";
          }
        else
          {
            $variable_output{$command_line_variable} .= " $1";
          }
      }
    else
      {
        $ierr = -1;
        &print_error( "Unrecognized command line argument:",
                      "[$command_line_variable$command_line_variables{$command_line_variable}]",
                      $ierr
                    );
        exit( $ierr );
      }
  }
#.........................................
#...DONE: assign command line variables...
#.........................................
#..............................
#...assign default variables...
#..............................
if( $only eq "false" )
  {
    #.............
    #...DIR_PWD...
    #.............
    $variable = "DIR_PWD";
    if ( defined( $variable_output{$variable} ) )
      {
        $ierr = -1;
        &print_error( "Redefining predefined variable:", "[$variable]",
                      $ierr );
        exit( $ierr );
      }
    $variable_assign{$variable} = ":=";
    $variable_output{$variable} =
      '$(shell '.$current_working_directory_command.')';
    #................
    #...DIR_DSTDIR...
    #................
    $variable = "DIR_DSTDIR";
    if ( defined( $variable_output{$variable} ) )
      {
        $ierr = -1;
        &print_error( "Redefining predefined variable:", "[$variable]",
                      $ierr );
        exit( $ierr );
      }
    $variable_assign{$variable} = "=";
    $variable_output{$variable} = '$(DIR_PREFIX)/$(DIR_RELDIR)';
    #................
    #...DIR_PREFIX...
    #................
    $variable = "DIR_PREFIX";
    if ( defined( $variable_output{$variable} ) )
      {
        $ierr = -1;
        &print_error( "Redefining predefined variable:", "[$variable]",
                      $ierr );
        exit( $ierr );
      }
    $variable_assign{$variable} = "=";
    $variable_output{$variable} = "$output_dir";
    #................
    #...DIR_RELDIR...
    #................
    $variable = "DIR_RELDIR";
    if ( defined( $variable_output{$variable} ) )
      {
        $ierr = -1;
        &print_error( "Redefining predefined variable:", "[$variable]",
                      $ierr );
        exit( $ierr );
      }
    $variable_assign{$variable} = "=";
    $variable_output{$variable} =
      '$(patsubst /%,%,$(patsubst $(DIR_TOP_SRCDIR)%,%,$(DIR_PWD)))';
    #................
    #...DIR_SRCDIR...
    #................
    $variable = "DIR_SRCDIR";
    if ( defined( $variable_output{$variable} ) )
      {
        $ierr = -1;
        &print_error( "Redefining predefined variable:", "[$variable]",
                      $ierr );
        exit( $ierr );
      }
    $variable_assign{$variable} = "=";
    $variable_output{$variable} = '$(DIR_TOP_SRCDIR)/$(DIR_RELDIR)';
    #....................
    #...DIR_TOP_SRCDIR...
    #....................
    $variable = "DIR_TOP_SRCDIR";
    if ( defined( $variable_output{$variable} ) )
      {
        $ierr = -1;
        &print_error( "Redefining predefined variable:", "[$variable]",
                      $ierr );
        exit( $ierr );
      }
    $variable_assign{$variable} = "=";
    $variable_output{$variable} = $current_working_directory;
    #................
    #...ECHO_GMAKE...
    #................
    $variable = "ECHO_GMAKE";
    if ( defined( $variable_output{$variable} ) )
      {
        $ierr = -1;
        &print_error( "Redefining predefined variable:", "[$variable]",
                      $ierr );
        exit( $ierr );
      }
    $variable_assign{$variable} = "=";
    $variable_output{$variable} = '$(ECHO) --gmake "$@ ($(DIR_RELDIR))--"';
    #..................
    #...PRODUCT_NAME...
    #..................
    $variable = "PRODUCT_NAME";
    if ( defined( $variable_output{$variable} ) )
      {
        $ierr = -1;
        &print_error( "Redefining predefined variable:", "[$variable]",
                      $ierr );
        exit( $ierr );
      }
    $variable_assign{$variable} = "=";
    ($variable_output{$variable} = $variable_output{"DIR_TOP_SRCDIR"}) =~
      s/^.*\/([^\/]+)$/$1/;
    #.......................
    #...CONFIGURE_OPTIONS...
    #.......................
    $variable = "CONFIGURE_OPTIONS";
    if ( defined( $variable_output{$variable} ) )
      {
        $ierr = -1;
        &print_error( "Redefining predefined variable:", "[$variable]",
                      $ierr );
        exit( $ierr );
      }
    $variable_assign{$variable} = "=";
    $variable_output{$variable} = $options;
    #...................
    #...COMPUTER_NAME...
    #...................
    $variable = "COMPUTER_NAME";
    if ( defined( $variable_output{$variable} ) )
      {
        $ierr = -1;
        &print_error( "Redefining predefined variable:", "[$variable]",
                      $ierr );
        exit( $ierr );
      }
    $variable_assign{$variable} = "=";
    $variable_output{$variable} = $computer_name;
    #....................
    #...CVS_ACCESSIBLE...
    #....................
    $variable = "CVS_ACCESSIBLE";
    if ( defined( $variable_output{$variable} ) )
      {
        $ierr = -1;
        &print_error( "Redefining predefined variable:", "[$variable]",
                      $ierr );
        exit( $ierr );
      }
    $variable_output{$variable} = "";
    if ( -d "CVS" )
      {
        $output = `cvs status -v README`;
        if ( ! defined( $output ) )
          {
            $output = "";
          }
        if ( $output =~ /\nFile: README/ )
          {
            $variable_output{$variable} = "true";
          }
      }
    $variable_assign{$variable} = "=";
    #.....................................................
    #...MAKE_INC_VARIABLES                             ...
    #...This must be done last to get all the variables...
    #.....................................................
    $variable = "MAKE_INC_VARIABLES";
    if ( defined( $variable_output{$variable} ) )
      {
        $ierr = -1;
        &print_error( "Redefining predefined variable:", "[$variable]",
                      $ierr );
        exit( $ierr );
      }
    $variable_output{$variable} = "";
    foreach $key ( sort keys %variable_output )
      {
        $variable_output{$variable} .= " $key";
      }
    $variable_assign{$variable} = "=";
    $variable_output{$variable} =~ s/^\s*//;
  }
#....................................
#...DONE: assign default variables...
#....................................
#......................................................
#...for lining up columns, get longest variable name...
#......................................................
$max_name_length = 0;
foreach $variable ( keys %variable_output )
  {
    #.................................
    #...and get maximum name length...
    #.................................
    if ( length ($variable) > $max_name_length )
      {
        $max_name_length = length ($variable);
      }
  }
#...for =/+=/...
$max_name_length += 3;
#........................................
#...prepare output string for printing...
#........................................
$total_output = "";
#..................
#...print header...
#..................
$total_output .= 
  "#................................................................\n".
  "#...$output_file_full                                             ...\n".
  "#...  Creation date: $date                            ...\n".
  "#...  This file is automatically generated by $0. ...\n".
  "#...  Permanent changes should be made to:                    ...\n".
  "#...       $0 or $input_file                    ...\n".
  "#................................................................\n";
#................................
#...print variable information...
#................................
@all_requirements = split ( /\s+/, $requirements_total );
foreach $requirement ( @all_requirements )
  {
    if ( $requirement =~ /\S/ )
      {
        $requirement_list {"$requirement"} = "true";
      }
  }
$total_output .= "\n#......................................................\n";
$total_output .= "#...All Valid Options:   ";
foreach $requirement ( sort keys %requirement_list )
  {
    $total_output .= "$requirement ";
  }
$total_output .= "\n#...\n#...Used Options: $options";
$total_output .= "\n#...\n#...Begin Command Line Args";
foreach $command_line_option( split( /\s+/, $command_line_options ) )
  {
    $total_output .= "\n#... $command_line_option";
  }
foreach $command_line_variable ( sort keys %command_line_variables )
  {
    $total_output .= "\n#... $command_line_variable$command_line_variables{$command_line_variable}";
  }
$total_output .= "\n#...End Command Line Args";
$total_output .= "\n#...\n#...$input_file Options: $datafile_options";
$total_output .= "\n#...\n#...$0 Predefined Options: $predefined_options";
$total_output .= "\n#...\n#...All Possible Predefined Options:\n";
foreach $key ( sort keys %predefined_options_all )
  {
    $total_output .= "#...   predefined $key: $predefined_options_all{$key}\n";
  }
$total_output .= "#......................................................\n";
#..............................................
#...format variable output into nice columns...
#..............................................
$variable_results = "";
foreach $variable ( sort keys %variable_output )
  {
    $variable_results .= "$variable ";
    for( $i = 0;
         $i < ( $max_name_length -
                length($variable) - length($variable_assign{$variable}) );
         $i++ )
      {
           $variable_results .= " ";
      }
    $variable_results .= $variable_assign{$variable};
    if( defined( $variable_output{$variable} ) )
      {
        $variable_results .= " $variable_output{$variable}";
      }
    $variable_results .= "\n";
  }
$total_output .= "\n\n".
  "#.....................\n".
  "#...variable output...\n".
  "#.....................\n\n";
$total_output .= $variable_results;
#...............................
#...print the verbatim things...
#...............................
$total_output .= "\n\n".
  "#.....................\n".
  "#...verbatim output...\n".
  "#.....................\n\n";
if( defined( $block{verbatim} ) )
  {
    $total_output .= $block{verbatim};
  }
#.....................................
#...if printing help message, do so...
#.....................................
if( $help eq "true" )
  {
    if( defined( $block{help} ) )
        {
          print $block{help};
        }
    else
      {
        print "\nNo 'begin help:' found in $input_file\n\n";
      }
  }
#................................
#...if printing to file, do so...
#................................
elsif ( $create_file eq "true" )
  {
    print "    Creating output file [$output_file_full]\n";
    print "    Options: [$options]\n";
    print "    Variables:\n";
    foreach $command_line_variable ( sort keys %command_line_variables )
      {
        print "     $command_line_variable$command_line_variables{$command_line_variable}\n";
      }
    print "\n";
    if( ! -d $output_dir )
      {
        $output = `mkdir -p $output_dir 2>&1`;
        if( $output =~ /\S/ )
          {
            $ierr = -1;
            &print_error( "Cannot create output directory [$output_dir]",
                          $output, $ierr );
            exit( $ierr );
          }
      }
    if ( ! open ( FILE, ">$output_file_full" ) )
      {
        $ierr = -1;
        &print_error( "Cannot open output file [$output_file_full]",
                      "Perhaps you need to make the directory?", $ierr );
        exit( $ierr );
      }
    print FILE $total_output;
    close FILE;
  }
#.............................................................
#...otherwise, print to screen and print info about options...
#.............................................................
else
  {
    print $total_output;
  }
#.........
#...end...
#.........
exit( 0 );
#.........................................................................
#...Name
#...====
#... get_variable_output
#...
#...Purpose
#...=======
#... get list of variables that are maximally satisfied by the options
#...
#...Arguments
#...=========
#... variable_group_ref    Intent: in
#...                       Perl type: hash_ref
#...                       hash containing {variable}="req=value\n<repeat>"
#...
#... options               Intent: in
#...                       Perl type: scalar
#...                       options set for this variable group
#...
#... variable_output_ref   Intent: out
#...                       Perl type: hash_ref
#...                       hash containing {variable}="value"
#...
#... variable_output_ref   Intent: out
#...                       Perl type: hash_ref
#...                       hash containing {variable}="assignment"
#...
#...Program Flow
#...============
#... 1) get hash of variables that are satisfied
#... 2) get maximally satisfied list from satisfied variables
#.........................................................................
sub get_variable_output
  {
    my(
       $variable_group_ref,
       $options,
       $variable_output_ref,
       $variable_assign_ref,
      ) = @_;
    #........................
    #...Local Declarations...
    #........................
    my(
       $assignment, # =/+=/...
       %additional_value, # if given a +=
       $ierr, # error value
       $requirement_group, # | split sections of requirement
       $requirement_number, # current number of reqs for satisfied variable
       $requirement_number_max, # max number of reqs for satisfied variable
       $requirements, # all requirements of a variable in input file
       @requirements_array, # array of $requirements
       $satisfied, # whether this variable(requirements)=value is satisfied
       %seen, # for unique-sort list
       $value, # value of variable in input file
       %variable_satisfied, # satisfied %variable_group
       $variable, # variable in input file
       $variable_line, # one variable_lines
       @variable_lines, # list of requirement=value pairs for a variable
      );
    #...........................
    #...Executable Statements...
    #...........................
    #..........
    #...init...
    #..........
    undef ( %variable_satisfied );
    undef ( %additional_value );
    #..............................................
    #...get hash of variables that are satisfied...
    #..............................................
    foreach $variable ( sort keys %$variable_group_ref )
      {
        #..................................
        #...init so no additional values...
        #..................................
        $additional_value{"$variable"} = "";
        #..............................................
        #...check all possibilities of this variable...
        #..............................................
        @variable_lines = split ( /\n/, $$variable_group_ref{"$variable"} );
        foreach $variable_line ( @variable_lines )
          {
            #.....................................................
            #...get the requirements and the value of this line...
            #.....................................................
            if( $variable_line =~
                /^
                ([^\073]*)\073 # requirements;
                ([^\073]*)\073 # assignment;
                (.*)$ # value
                /x )
              {
                $requirements = $1;
                $assignment = $2;
                $value = $3;
              }
            else
              {
                $ierr = -1;
                &print_error( "Variable line malformed",
                              "[$variable_line]",
                              $ierr );
                exit $ierr;
              }
            #.........................
            #...format requirements...
            #.........................
            if( $requirements !~ /\S/ )
              {
                $requirements = " ";
              }
            $requirements =~ s/\s*\!\s*/ \!/g; #... !requirement...
            #..............................................
            #...get satisfied for each requirement group...
            #..............................................
            $requirement_number = -1;
            foreach $requirement_group ( split( /\s*\|\s*/, $requirements ) )
              {
                #....................................
                #...process this requirement group...
                #....................................
                $satisfied = "true";
                %seen = ();
                $requirement_group =~ s/^\s+//;
                $requirement_group =~ s/\s+$//;
                @requirements_array = 
                  sort grep{ ! $seen{$_}++ } 
                  split ( /\s+/, $requirement_group );
                foreach $requirement ( @requirements_array )
                  {
                    #.....................
                    #...not requirement...
                    #.....................
                    if( $requirement =~ /^\!/ )
                      {
                        $requirement =~ s/^\!//;
                        if ( " $options " =~ /\b$requirement\b/ )
                          {
                            $satisfied = "false";
                            last;
                          }
                      }
                    #.................
                    #...requirement...
                    #.................
                    else
                      {
                        if ( " $options " !~ /\b$requirement\b/ )
                          {
                            $satisfied = "false";
                            last;
                          }
                      }
                  }
                #..........................................
                #...DONE: process this requirement group...
                #..........................................
                #.............................
                #...save requirement_number...
                #.............................
                if( $satisfied eq "true" )
                  {
                    if( $#requirements_array + 1 > $requirement_number )
                      {
                        $requirement_number = $#requirements_array + 1;
                      }
                  }
              }
            #....................................................
            #...DONE: get satisfied for each requirement group...
            #....................................................
            #.................................................
            #...if satisfied, remember based on $assignment...
            #.................................................
            if ( $requirement_number >= 0 )
              {
                if ( "$assignment" ne "+=" )
                  {
                    if ( ! defined $variable_satisfied{"$variable"} )
                      {
                        $variable_satisfied{"$variable"} = "";
                      }
                    $variable_satisfied{"$variable"} .=
                      "$requirement_number$assignment$value\n"; 
                  }
                else
                  {
                    $additional_value{"$variable"} .= " $value";
                  }
              }
            #.......................................................
            #...DONE: if satisfied, remember based on $assignment...
            #.......................................................
          }
        #....................................................
        #...DONE: check all possibilities of this variable...
        #....................................................
      }
    #....................................................
    #...DONE: get hash of variables that are satisfied...
    #....................................................
    #...........................................................
    #...get maximally satisfied list from satisfied variables...
    #...........................................................
    foreach $variable ( sort keys %variable_satisfied )
      {
        @variable_lines = split ( /\n/, $variable_satisfied{"$variable"} );
        #.................................................................
        #...find the variable line with the largest set of requirements...
        #.................................................................
        $requirement_number_max = -1;
        foreach $variable_line ( @variable_lines )
          {
            #.....................................................
            #...get the requirements and the value of this line...
            #.....................................................
            ( $requirement_number = $variable_line ) =~
              s/^([0-9]+)((:)?=)(.*)$/$1/;
            $assignment = $2;
            $value = $4;
            #.....................................................
            #...if you have a larger number of requirements for...
            #...that variable, remember it                     ...
            #.....................................................
            if ( $requirement_number > $requirement_number_max )
              {
                $$variable_output_ref{"$variable"} = "$value";
                $$variable_assign_ref{"$variable"} = "$assignment";
                $requirement_number_max = $requirement_number;
              }
          }
        #................................................................
        #...DONE: found the largest set of requirements for a variable...
        #................................................................
      }
    #.................................................................
    #...DONE: get maximally satisfied list from satisfied variables...
    #.................................................................
    #.............................
    #...add on additional_value...
    #.............................
    foreach $variable ( sort keys %additional_value )
      {
        if ( $additional_value{"$variable"} =~ /\S/ )
          {
            if ( defined( $$variable_output_ref{"$variable"} ) )
              {
                $$variable_output_ref{"$variable"} .= 
                  $additional_value{"$variable"};
              }
            else
              {
                $$variable_assign_ref{"$variable"} = "=";
                $$variable_output_ref{"$variable"} =
                  $additional_value{"$variable"};
                $$variable_output_ref{"$variable"} =~ s/^ //;
              }
          }
      }

    #............
    #...return...
    #............
    return( 0 );
  }
#.........................................................................
#...Name
#...====
#... exclusive_prune
#...
#...Purpose
#...=======
#... prune all but 1 of any exclusive arguments
#...
#...Arguments
#...=========
#... exclusive_lines       Intent: in
#...                       Perl type: scalar
#...                       lines grouping exclusive opts separated by \n,
#...                       exclusive options separated by whitespace
#...
#... options               Intent: in
#...                       Perl type: scalar_ref
#...                       options to be pruned separated by whitespace
#...                       Options should be "ordered" beforehand so that
#...                       if exclusion occurs, the first option remains.
#...                       So, have order be:
#...                            predefined, command line, configure.dat
#...
#...
#...Program Flow
#...============
#... 1) go through each exclusive line
#... 1.1) go through each exclusive option
#... 1.1.1) if an option matches an exclusive option
#... 1.1.1.1) remove all exclusive options from line
#... 1.1.1.2) all back in the one exclusive option and reconstitute
#... 1.1.1.3) last (go to next exclusive line)
#.........................................................................
sub exclusive_prune
  {
    #...............
    #...arguments...
    #...............
    my(
       $exclusive_lines,
       $options_ref
      ) = @_;
    #........................
    #...Local Declarations...
    #........................
    my(
       $exclusive_line, # split \n on exclusive_lines
       @exclusive_options, # array of split \s+ $exclusive_lines
       $i, # loop variable
       $j, # loop variable
       $option_is_exclusive, # if option is on exclusive line
       %seen, # used for unique sort
      );
    #................................................................
    #...prepare exclusive lines for splitting on \n and whitespace...
    #................................................................
    $exclusive_lines =~ s/^\s*//;
    $exclusive_lines =~ s/\s*$//;
    $exclusive_lines =~ s/\s*\n\s*/\n/g;
    $exclusive_lines =~ s/[ \t]+/ /g;
    #.........................
    #...unique sort options...
    #.........................
    $$options_ref =~ s/^\s*//;
    $$options_ref =~ s/\s*$//;
    $$options_ref =~ s/\s+/ /g;
    #...................................................
    #...foreach exclusive line in the exclusive block...
    #...................................................
    foreach $exclusive_line ( split( /\n/, $exclusive_lines ) )
      {
        #......................
        #...unique sort list...
        #......................
        %seen = ();
        @exclusive_options =
          sort grep{ ! $seen{$_}++ } split( /\s+/, $exclusive_line );
        @options = split( /\s+/, $$options_ref );
        #...........................................................
        #...go through each option and remove exclusives after it...
        #...........................................................
        for( $i = 0; $i < $#options; $i++ )
          {
            #......................................
            #...go through each exclusive option...
            #......................................
            $option_is_exclusive = "false";
            for( $j = 0; $j <= $#exclusive_options; $j++ )
              {
                if( $options[$i] =~ /^\b$exclusive_options[$j]\b$/ )
                  {
                    #................................................
                    #...remove exclusives after this one from list...
                    #................................................
                    for( $k = $i+1; $k <= $#options; $k++ )
                      {
                        for( $l = 0; $l <= $#exclusive_options; $l++ )
                          {
                            if( $options[$k] =~
                                /^\b$exclusive_options[$l]\b$/ )
                              {
                                $options[$k] = "";
                                last;
                              }
                          }
                      }
                    #......................................................
                    #...DONE: remove exclusives after this one from list...
                    #......................................................
                    $option_is_exclusive = "true";
                    last;
                  }
              }
            #............................................
            #...DONE: go through each exclusive option...
            #............................................
            if( $option_is_exclusive eq "true" )
              {
                last;
              }
          }
        #.................................................................
        #...DONE: go through each option and remove exclusives after it...
        #.................................................................
        $$options_ref = join( ' ', @options );
        $$options_ref =~ s/^\s*//;
        $$options_ref =~ s/\s*$//;
        $$options_ref =~ s/\s+/ /g;
      }
    #...................................................
    #...foreach exclusive line in the exclusive block...
    #...................................................
    return( 0 );
  }
#............................................................................
#...Name
#...====
#... path_comp
#...
#...Purpose
#...=======
#... compresses path (Removes extra ".", "./", "/", foo/..)
#...
#...Arguments
#...=========
#... dir Intent: in
#...     Perl type: string scalar
#...
#...Program Flow
#...============
#... 1) go through go through path to find exec
#............................................................................
sub path_comp
  {
    my( $pi ) = @_; # path input to compress
    my(
       $d, # "."
       $dd, # ".."
       @po, # path output
       $p, # current path in question
       $n, # ""
       $s, # "/"
      );
    $d=".";
    $dd="..";
    $s="/";
    $n="";
    push(@po,$s) if substr($pi,0,1) eq $s;
    foreach $p (split($s,$pi))
      {
        next if $p eq $n or $p eq $d;
        if($p eq $dd)
          {
            if($#po>=0 and $po[-1] ne $dd )
              {
                pop(@po) if $po[-1] ne $s;
                next;
              }
          }
        push(@po,$p);
      }
    push(@po,$d) if $#po<0;
    $po[0]=$n if($#po>0 and $po[0] eq $s);
    return(join($s,@po));
  }
#............................................................................
#...Name
#...====
#... print_error
#...
#...Purpose
#...=======
#... Print a standard error message.
#...
#...Arguments
#...=========
#... error_lines  Intent: in
#...              Perl type: array
#...              0: cause of error (file_name:line_number)
#...              1: explanation/fix (if there is one)
#...              2: error value
#...
#...Program Flow
#...============
#... 1) see if warning or error (last argument is 0 or not)
#... 2) Line up error lines by column
#... 3) find out who was calling this routine and the line number
#... 4) print out info
#............................................................................
sub print_error
  {
    my( 
       @error_lines # what emitted the error
      ) = @_;
    my(
       $error_level,  # what is printed (eg WARNING or ERROR)
       $error_line,   # each line of input argument
       @routine_info, # var from caller
       $routine_name, # routine name
       $spaces        # spaces for lining up columns
      );
    #......................................................
    #...assign WARNING or ERROR depending on error value...
    #......................................................
    if ( "$error_lines[$#error_lines]" eq "0" )
      {
        $error_level = "**WARNING**";
        $spaces      = "           ";
      }
    else
      {
        $error_level = "**ERROR**";
        $spaces      = "         ";
      }
    #............................................................
    #...DONE: assign WARNING or ERROR depending on error value...
    #............................................................
    #.......................................
    #...init error and add argument lines...
    #.......................................
    $error_line = shift( @error_lines );
    $error_message = "\n$error_level $error_line\n";
    foreach $error_line ( @error_lines )
      {
        $error_message .= "$spaces $error_line\n";
      }
    #............................................................
    #...get routine name (special if called from main program)...
    #............................................................
    @routine_info = caller(1);
    if ( $#routine_info < 3 )
      {
        $routine_name = $0;
      }
    else
      {
        $routine_name = (caller(1))[3];
      }
    $routine_name = $routine_name.":".(caller(0))[2];
    #...........................
    #...postpend routine name...
    #...........................
    $error_message .= "$spaces $routine_name\n";
    #.................
    #...print error...
    #.................
    print STDERR $error_message;
  }
#............................................................................
#...Name
#...====
#... which_exec
#...
#...Purpose
#...=======
#... Returns value for full path to executable ("" if not found).
#...
#...Arguments
#...=========
#... exec Intent: in
#...      Perl type: string scalar
#...
#...Program Flow
#...============
#... 1) go through path to find exec
#............................................................................
sub which_exec
  {
    my( 
       $exec, # exec to find
      ) = @_;
    my(
       $ierr, # error return value
       $exec_try, # see if exec is here
       $found, # if found
       $path, # current dir in search for execs
       @paths, # list of search paths for execs
       $this_dir, # current directory
      );
    #.................................................
    #...build paths from PATH and current directory...
    #.................................................
    $path = $ENV{PATH};
    @paths = split( /:/, $ENV{PATH} );
    ($this_dir = $0) =~ s/\/[^\/]+$//;
    unshift( @paths, $this_dir );
    #.....................................
    #...loop through paths to find exec...
    #.....................................
    $found = "false";
    foreach $path (@paths)
      {
        $exec_try = "$path/$exec";
        if( -x "$exec_try" )
          {
            $found = "true";
            last;
          }
      }
    #........................................
    #...error if still could not find exec...
    #........................................
    if( $found eq "false" )
      {
        $ierr = -1;
        &print_error(
                     "Necessary executable [$exec] not found in PATH",
                     $ierr
                    );
        exit( $ierr );
      }
    return( $exec_try );
  }
